#pragma once

#include <windows.h>
#include <strsafe.h>
#include <Winternl.h>

extern "C" {

	typedef struct _CURDIR
	{
		UNICODE_STRING DosPath;
		HANDLE Handle;

	} CURDIR, *PCURDIR;


	typedef struct _SECTION_IMAGE_INFORMATION
	{
		PVOID TransferAddress;
		ULONG ZeroBits;
		ULONG_PTR MaximumStackSize;
		ULONG_PTR CommittedStackSize;
		ULONG SubSystemType;
		union _SECTION_IMAGE_INFORMATION_u0
		{
			struct _SECTION_IMAGE_INFORMATION_s0
			{
				USHORT SubSystemMinorVersion;
				USHORT SubSystemMajorVersion;
			};
			ULONG SubSystemVersion;
		};
		ULONG GpValue;
		USHORT ImageCharacteristics;
		USHORT DllCharacteristics;
		USHORT Machine;
		BOOLEAN ImageContainsCode;
		BOOLEAN Spare1;
		ULONG LoaderFlags;
		ULONG Reserved[2];

	} SECTION_IMAGE_INFORMATION, *PSECTION_IMAGE_INFORMATION;

	typedef struct _CLIENT_ID
	{
		HANDLE UniqueProcess;
		HANDLE UniqueThread;

	} CLIENT_ID, *PCLIENT_ID;

	typedef struct _RTL_USER_PROCESS_INFORMATION
	{
		ULONG Length;
		HANDLE ProcessHandle;
		HANDLE ThreadHandle;
		CLIENT_ID ClientId;
		SECTION_IMAGE_INFORMATION ImageInformation;

	} RTL_USER_PROCESS_INFORMATION, *PRTL_USER_PROCESS_INFORMATION;

	NTSYSAPI NTSTATUS NTAPI NtWriteFile(
		HANDLE           FileHandle,
		HANDLE           Event,
		PIO_APC_ROUTINE  ApcRoutine,
		PVOID            ApcContext,
		PIO_STATUS_BLOCK IoStatusBlock,
		PVOID            Buffer,
		ULONG            Length,
		PLARGE_INTEGER   ByteOffset,
		PULONG           Key
	);

	NTSYSAPI BOOLEAN NTAPI RtlDosPathNameToNtPathName_U(
		IN  PWSTR DosPathName,
		OUT PUNICODE_STRING NtPathName,
		OUT PWSTR * NtFileNamePart OPTIONAL,
		OUT PCURDIR DirectoryInfo OPTIONAL
	);

	NTSYSAPI NTSTATUS NTAPI RtlCreateProcessParameters(
		PRTL_USER_PROCESS_PARAMETERS *ProcessParameters,
		PUNICODE_STRING ImagePathName,
		PUNICODE_STRING DllPath,
		PUNICODE_STRING CurrentDirectory,
		PUNICODE_STRING CommandLine,
		PVOID Environment,
		PUNICODE_STRING WindowTitle,
		PUNICODE_STRING DesktopInfo,
		PUNICODE_STRING ShellInfo,
		PUNICODE_STRING RuntimeData
	);

	NTSYSAPI NTSTATUS NTAPI RtlCreateUserProcess(
		PUNICODE_STRING NtImagePathName,
		ULONG Attributes,
		PRTL_USER_PROCESS_PARAMETERS ProcessParameters,
		PSECURITY_DESCRIPTOR ProcessSecurityDescriptor,
		PSECURITY_DESCRIPTOR ThreadSecurityDescriptor,
		HANDLE ParentProcess,
		BOOLEAN InheritHandles,
		HANDLE DebugPort,
		HANDLE ExceptionPort,
		PRTL_USER_PROCESS_INFORMATION ProcessInformation
	);

	NTSYSAPI NTSTATUS NTAPI NtResumeThread(
		IN HANDLE ThreadHandle,
		OUT PULONG PreviousSuspendCount OPTIONAL
	);

	NTSYSAPI NTSTATUS NTAPI RtlDestroyProcessParameters(
		PRTL_USER_PROCESS_PARAMETERS ProcessParameters
	);

}

#pragma intrinsic(memset, strlen)

void __stdcall RunProcess(PWSTR Path, PWSTR Cmd);
